package com.baidu.cloud.videoplayer.demo;

import com.baidu.cloud.license.LicenseManager;
import com.baidu.cloud.videoplayer.demo.helper.DefaultActivityManager;

import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;

public class BaseApp extends Application {
    private static final String TAG = "BaseApp";
    private static Context sContext;
    private static DefaultActivityManager activityManager;

    /**
     * 您的AppId(LicenseId) 请到https://console.bce.baidu.com/bvc/#/bvc/player-license/list申请获取
     */
    public static final String APP_ID = "98777963030676377601p";

    @Override
    public void onCreate() {
        super.onCreate();
        sContext = this;

        LicenseManager.init(sContext, BaseApp.APP_ID);
        if (!LicenseManager.isValid()) {
            // 业务方可以在此处添加重试机制等自定义逻辑
            Log.e(TAG, "Authentication failure, errcode: " + LicenseManager.getErrCode());
        }

        activityManager = new DefaultActivityManager();
        registerActivityLifecycleCallbacks(new ActivityLifecycleCallbacks() {
            @Override
            public void onActivityCreated(Activity activity, Bundle savedInstanceState) {

            }

            @Override
            public void onActivityStarted(Activity activity) {

            }

            @Override
            public void onActivityResumed(Activity activity) {
                DefaultActivityManager.setCurrentActivity(activity);
            }

            @Override
            public void onActivityPaused(Activity activity) {

            }

            @Override
            public void onActivityStopped(Activity activity) {

            }

            @Override
            public void onActivitySaveInstanceState(Activity activity, Bundle outState) {

            }

            @Override
            public void onActivityDestroyed(Activity activity) {

            }
        });

    }

    public static Context getAppContext() {
        return sContext;
    }

    public static DefaultActivityManager getActivityManager() {
        return activityManager;
    }
}
