package com.baidu.cloud.videoplayer.demo.helper;

import android.content.Context;
import android.view.Surface;

public class VrKitWrapper {
    private static final String VRKIT_CLASS_NAME = "com.baidu.cloud.vrkit.VRKit";
    private static final String VRRENDERVIEW_CLASS_NAME = "com.baidu.cloud.videoplayer.widget"
            + ".VrRenderView";
    private static final String GLTEXTUREVIEW_CLASS_NAME = "com.google.android.apps.muzei.render"
            + ".GLTextureView";

    public static Object constructVrKit() {
        Class[] types = {};
        Object[] params = {};

        return CommonUtils.Load(VRKIT_CLASS_NAME, types, params);
    }

    public static void init(Object vrkitObject, Context context, String appid) {
        try {
            Class[] types = {Context.class, String.class};
            Object[] params = {context, appid};
            CommonUtils.Load(vrkitObject, "init", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void release(Object vrkitObject) {
        try {
            Class[] types = {};
            Object[] params = {};
            CommonUtils.Load(vrkitObject, "release", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void prepareWithTargetSurface(Object vrkitObject, Object vrRenderView) {
        try {
            Class[] types = {Class.forName(GLTEXTUREVIEW_CLASS_NAME)};
            Object[] params = {vrRenderView};
            CommonUtils.Load(vrkitObject, "prepareWithTargetSurface", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static Surface getInputSurface(Object vrkitObject) {
        try {
            Class[] types = {};
            Object[] params = {};
            return (Surface) CommonUtils.Load(vrkitObject, "getInputSurface", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public static void onVideoSizeChanged(Object vrkitObject, int inputWidth, int inputHeight) {
        try {
            Class[] types = {Integer.TYPE, Integer.TYPE};
            Object[] params = {inputWidth, inputHeight};
            CommonUtils.Load(vrkitObject, "onVideoSizeChanged", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void onPlayerPrepared(Object vrkitObject) {
        try {
            Class[] types = {};
            Object[] params = {};
            CommonUtils.Load(vrkitObject, "onPlayerPrepared", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void start(Object vrkitObject) {
        try {
            Class[] types = {};
            Object[] params = {};
            CommonUtils.Load(vrkitObject, "start", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void pause(Object vrkitObject) {
        try {
            Class[] types = {};
            Object[] params = {};
            CommonUtils.Load(vrkitObject, "pause", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static Object constructVrRenderView(Context context) {
        Class[] types = {Context.class};
        Object[] params = {context};

        return CommonUtils.Load(VRRENDERVIEW_CLASS_NAME, types, params);
    }

    public static Object getSurfaceHolder(Object vrRenderViewObject) {
        try {
            Class[] types = {};
            Object[] params = {};
            return CommonUtils.Load(vrRenderViewObject, "getSurfaceHolder", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public static void setVideoSize(Object vrRenderViewObject, int w, int h) {
        try {
            Class[] types = {Integer.TYPE, Integer.TYPE};
            Object[] params = {w, h};
            CommonUtils.Load(vrRenderViewObject, "setVideoSize", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void setVideoSampleAspectRatio(Object vrRenderViewObject, int sarnum,
                                                 int sarden) {
        try {
            Class[] types = {Integer.TYPE, Integer.TYPE};
            Object[] params = {sarnum, sarden};
            CommonUtils.Load(vrRenderViewObject, "setVideoSampleAspectRatio", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void setAspectRatio(Object vrRenderViewObject, int ratio) {
        try {
            Class[] types = {Integer.TYPE};
            Object[] params = {ratio};
            CommonUtils.Load(vrRenderViewObject, "setAspectRatio", types, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
