package com.baidu.cloud.videoplayer.demo.info;

import android.text.TextUtils;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

public class CpuInfo {
    private static final String TAG = CpuInfo.class.getSimpleName();
    private static final int TOP_HEADER_LINE_NUM = 6;

    public static float getCpuUsage() {
        float cpuPercent = 0f;
        int pid = android.os.Process.myPid();
        String topCmd = "top -n 1 -p " + pid;
        try {
            InputStream inputStream = Runtime.getRuntime().exec(topCmd).getInputStream();
            BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
            String line = "";
            int lineNum = 0;
            while (!TextUtils.isEmpty(line = bufferedReader.readLine())) {
                lineNum++;
                if (lineNum == TOP_HEADER_LINE_NUM) {
                    String[] splitLine = line.trim().split("\\s+");
                    // 12384 u0_a351      10 -10 5.0G 216M 101M S  139   3.7   2:27.92 pname
                    if (isDigit(splitLine[0]) && Integer.parseInt(splitLine[0]) == pid) {
                        cpuPercent = Float.parseFloat(splitLine[8]);
                    }
                    break;
                }
            }
        } catch (IOException|NumberFormatException e) {
            e.printStackTrace();
        }
        return cpuPercent;
    }

    private static boolean isDigit(String in) {
        for (char c : in.toCharArray()) {
            if (!Character.isDigit(c)) {
                return false;
            }
        }
        return true;
    }
}
